classdef webcam < handle
  properties
    cam
    figh
  endproperties

  methods
    function obj = webcam(varargin)
      obj.cam = kpc_webcam(varargin{:});
    endfunction

    function im = snapshot(obj)
      im = kpc_snapshot(obj.cam);
    endfunction

    function preview(obj)
      if (isempty(obj.figh))
        obj.figh = figure;
      else
        figure(obj.figh)
      end
      imshow(snapshot(obj));
      title('Live preview not implemented. This is a still image');
      drawnow;
      warning('Live preview not implemented. A still image is shown instead');
    endfunction
    
    function closepreview(obj)
      close(obj.figh);
      obj.figh = [];
    endfunction

    function varargout = get(obj, varargin)
      [varargout{1:nargout}] = kpc_webcam_get(obj.cam, varargin{:});
    endfunction

    function varargout = set(obj, varargin)
      [varargout{1:nargout}] = kpc_webcam_set(obj.cam, varargin{:});
    endfunction
  endmethods
endclassdef
